%global momorel 1

%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
# Build ocaml bits unless rpmbuild was run with --without ocaml 
# or ocamlopt is missing (the xen makefile doesn't build ocaml bits if it isn't there)
%global with_ocaml  %{?_without_ocaml: 0} %{?!_without_ocaml: 1}
%global build_ocaml %(test -x %{_bindir}/ocamlopt && echo %{with_ocaml} || echo 0)
# build xsm support unless rpmbuild was run with --without xsm
# or required packages are missing
%global with_xsm  %{?_without_xsm: 0} %{?!_without_xsm: 1}
%global build_xsm %(test -x %{_bindir}/checkpolicy && test -x %{_bindir}/m4 && echo %{with_xsm} || echo 0)
# cross compile 64-bit hypervisor on ix86 unless rpmbuild was run
%global build_crosshyp 0
%ifnarch %{ix86}
%global build_crosshyp 0
%global build_hyp 1
%else
%if %build_crosshyp
%global build_hyp 1
%else
%global build_hyp 0
# no point in trying to build xsm on ix86 without a hypervisor
%global build_xsm 0
%endif
%endif
# build an efi boot image (where supported) unless rpmbuild was run with
%global build_efi 0
# xen only supports efi boot images on x86_64
%ifnarch x86_64
%global build_efi 0
%endif
%global with_sysv 0
%global with_systemd 1
%global with_systemd_presets 1

# Hypervisor ABI
%global hv_abi  4.5

Summary: Xen is a virtual machine monitor
Name:    xen
Version: 4.5.0
Release: %{momorel}m%{?dist}
Group:   Development/Libraries
License: GPLv2+ and LGPLv2+ and BSD
URL:     http://xen.org/
Source0: http://bits.xensource.com/oss-xen/release/%{version}/xen-%{version}.tar.gz
Source1: %{name}.modules
Source2: %{name}.logrotate
# used by stubdoms
Source10: http://download.savannah.gnu.org/releases/lwip/older_versions/lwip-1.3.0.tar.gz
NoSource: 10
Source11: ftp://sourceware.org/pub/newlib/newlib-1.16.0.tar.gz
NoSource: 11
Source12: https://google-desktop-for-linux-mirror.googlecode.com/files/zlib-1.2.3.tar.gz
NoSource: 0
Source13: https://www.kernel.org/pub/software/utils/pciutils/pciutils-2.2.9.tar.bz2
NoSource: 13
Source14: http://alpha.gnu.org/gnu/grub/grub-0.97.tar.gz
NoSource: 14
Source15: https://polarssl.org/code/releases/polarssl-1.1.4-gpl.tgz
NoSource: 15
# init.d bits
Source20: init.xenstored
Source21: init.xenconsoled
# sysconfig bits
Source30: sysconfig.xenstored
Source31: sysconfig.xenconsoled

Patch4: xen-dumpdir.patch
Patch5: xen-net-disable-iptables-on-bridge.patch

Patch10: pygrubfix.patch
Patch11: xen.use.fedora.ipxe.patch
Patch12: xen.fedora.efi.build.patch
Patch13: xen.xsm.enable.patch
Patch14: xen.64.bit.hyp.on.ix86.patch
Patch15: CVE-2014-0150.patch
Patch16: xen.fedora.systemd.patch
Patch17: xen.ocaml.uint.fix.patch
Patch18: xen.ocaml.selinux.fix.patch
Patch19: xsa118-4.5-unstable-1.patch
Patch20: xsa118-4.5-unstable-2.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: transfig libidn-devel zlib-devel texi2html SDL-devel curl-devel
BuildRequires: libX11-devel python-devel ghostscript
#BuildRequires: texlive-latex
#%if "%dist" >= ".fc18"
#BuildRequires: texlive-times texlive-courier texlive-helvetic texlive-ntgclass
#%endif
BuildRequires: ncurses-devel gtk2-devel libaio-devel
# for the docs
BuildRequires: perl perl(Pod::Man) perl(Pod::Text) texinfo graphviz
# so that the makefile knows to install udev rules
BuildRequires: udev
%ifarch %{ix86} x86_64
# so that x86_64 builds pick up glibc32 correctly
BuildRequires: /usr/include/gnu/stubs-32.h
# for the VMX "bios"
BuildRequires: dev86
%endif
BuildRequires: gettext
BuildRequires: gnutls-devel
BuildRequires: openssl-devel
# For ioemu PCI passthrough
BuildRequires: pciutils-devel
# Several tools now use uuid
BuildRequires: libuuid-devel
# iasl needed to build hvmloader
BuildRequires: iasl
# build using Fedora seabios and ipxe packages for roms
BuildRequires: seabios-bin
# FIXME
# BuildRequires: ipxe-roms-qemu
# modern compressed kernels
BuildRequires: bzip2-devel xz-devel
# libfsimage
BuildRequires: e2fsprogs-devel
# tools now require yajl and wget
BuildRequires: yajl-devel wget
%if %with_xsm
# xsm policy file needs needs checkpolicy and m4
BuildRequires: checkpolicy m4
%endif
%if %build_crosshyp
# cross compiler for building 64-bit hypervisor on ix86
BuildRequires: gcc-x86_64-linux-gnu
%endif
Requires: bridge-utils
Requires: python-lxml
Requires: udev >= 059
Requires: xen-runtime = %{version}-%{release}
# Not strictly a dependency, but kpartx is by far the most useful tool right
# now for accessing domU data from within a dom0 so bring it in when the user
# installs xen.
Requires: kpartx
Requires: chkconfig
ExclusiveArch: %{ix86} x86_64
#ExclusiveArch: %{ix86} x86_64 ia64 noarch
%if %with_ocaml
BuildRequires: ocaml, ocaml-findlib
%endif
# efi image needs an ld that has -mi386pep option
%if %build_efi
BuildRequires: mingw64-binutils
%endif
%if %with_systemd_presets
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
BuildRequires: systemd
%endif
%if %with_systemd
BuildRequires: systemd-devel
%endif

%description
This package contains the XenD daemon and xm command line
tools, needed to manage virtual machines running under the
Xen hypervisor

%package libs
Summary: Libraries for Xen tools
Group: Development/Libraries
Requires(pre): /sbin/ldconfig
Requires(post): /sbin/ldconfig
Requires: xen-licenses

%description libs
This package contains the libraries needed to run applications
which manage Xen virtual machines.


%package runtime
Summary: Core Xen runtime environment
Group: Development/Libraries
Requires: xen-libs = %{version}-%{release}
#Requires: /usr/bin/qemu-img /usr/bin/qemu-nbd
Requires: /usr/bin/qemu-img
# Ensure we at least have a suitable kernel installed, though we can't
# force user to actually boot it.
Requires: xen-hypervisor-abi = %{hv_abi}

%description runtime
This package contains the runtime programs and daemons which
form the core Xen userspace environment.


%package hypervisor
Summary: Libraries for Xen tools
Group: Development/Libraries
Provides: xen-hypervisor-abi = %{hv_abi}
Requires: xen-licenses

%description hypervisor
This package contains the Xen hypervisor


%package doc
Summary: Xen documentation
Group: Documentation
#BuildArch: noarch
Requires: xen-licenses

%description doc
This package contains the Xen documentation.


%package devel
Summary: Development libraries for Xen tools
Group: Development/Libraries
Requires: xen-libs = %{version}-%{release}
Requires: libuuid-devel

%description devel
This package contains what's needed to develop applications
which manage Xen virtual machines.


%package licenses
Summary: License files from Xen source
Group: Documentation

%description licenses
This package contains the license files from the source used
to build the xen packages.


%if %build_ocaml
%package ocaml
Summary: Ocaml libraries for Xen tools
Group: Development/Libraries
Requires: ocaml-runtime, xen-libs = %{version}-%{release}

%description ocaml
This package contains libraries for ocaml tools to manage Xen
virtual machines.


%package ocaml-devel
Summary: Ocaml development libraries for Xen tools
Group: Development/Libraries
Requires: xen-ocaml = %{version}-%{release}

%description ocaml-devel
This package contains libraries for developing ocaml tools to
manage Xen virtual machines.
%endif


%prep
%setup -q
%patch4 -p1
%patch5 -p1

%patch10 -p1
#%%patch11 -p1
%patch12 -p1
%if %build_xsm
%patch13 -p1
%endif
%if %build_crosshyp
%patch14 -p1
%endif
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1

# stubdom sources
cp -v %{SOURCE10} %{SOURCE11} %{SOURCE12} %{SOURCE13} %{SOURCE14} %{SOURCE15} stubdom


%build
%if !%build_ocaml
%global ocaml_flags OCAML_TOOLS=n
%endif
%if %build_efi
%global efi_flags LD_EFI=/usr/x86_64-w64-mingw32/bin/ld
mkdir -p dist/install/boot/efi/efi/fedora
%endif
%if %(test -f /usr/share/seabios/bios-256k.bin && echo 1|| echo 0)
%global seabiosloc /usr/share/seabios/bios-256k.bin
%else
%global seabiosloc /usr/share/seabios/bios.bin
%endif
export XEN_VENDORVERSION="-%{release}"
export CFLAGS="$RPM_OPT_FLAGS"
make %{?_smp_mflags} %{?efi_flags} prefix=/usr dist-xen
./configure --prefix=%{_prefix} --libdir=%{_libdir} --with-system-seabios=%{seabiosloc} --with-system-qemu=/usr/bin/qemu-system-i386
make %{?_smp_mflags} %{?ocaml_flags} prefix=/usr dist-tools
make                 prefix=/usr dist-docs
unset CFLAGS
make %{?ocaml_flags} dist-stubdom


%install
rm -rf %{buildroot}
%if %build_ocaml
mkdir -p %{buildroot}%{_libdir}/ocaml/stublibs
%endif
%if %build_efi
mkdir -p %{buildroot}/boot/efi/efi/fedora
%endif
make DESTDIR=%{buildroot} %{?efi_flags}  prefix=/usr install-xen
make DESTDIR=%{buildroot} %{?ocaml_flags} prefix=/usr install-tools
make DESTDIR=%{buildroot} prefix=/usr install-docs
make DESTDIR=%{buildroot} %{?ocaml_flags} prefix=/usr install-stubdom
%if %build_efi
mv %{buildroot}/boot/efi/efi %{buildroot}/boot/efi/EFI
%endif
%if %build_xsm
# policy file should be in /boot/flask
mkdir %{buildroot}/boot/flask
mv %{buildroot}/boot/xenpolicy* %{buildroot}/boot/flask
%else
rm -f %{buildroot}/boot/xenpolicy*
%endif

############ debug packaging: list files ############

find %{buildroot} -print | xargs ls -ld | sed -e 's|.*%{buildroot}||' > f1.list

############ kill unwanted stuff ############

# stubdom: newlib
rm -rf %{buildroot}/usr/*-xen-elf

# hypervisor symlinks
rm -rf %{buildroot}/boot/xen-4.0.gz
rm -rf %{buildroot}/boot/xen-4.gz
%if !%build_hyp
rm -rf %{buildroot}/boot
%endif

# silly doc dir fun
rm -fr %{buildroot}%{_datadir}/doc/xen
rm -rf %{buildroot}%{_datadir}/doc/qemu

# Pointless helper
rm -f %{buildroot}%{_sbindir}/xen-python-path

# qemu stuff (unused or available from upstream)
rm -rf %{buildroot}/usr/share/xen/man
rm -rf %{buildroot}/usr/bin/qemu-*-xen
ln -s qemu-img %{buildroot}/%{_bindir}/qemu-img-xen
ln -s qemu-img %{buildroot}/%{_bindir}/qemu-nbd-xen
for file in bios.bin openbios-sparc32 openbios-sparc64 ppc_rom.bin \
         pxe-e1000.bin pxe-ne2k_pci.bin pxe-pcnet.bin pxe-rtl8139.bin \
         vgabios.bin vgabios-cirrus.bin video.x openbios-ppc bamboo.dtb
do
	rm -f %{buildroot}/%{_datadir}/xen/qemu/$file
done

# README's not intended for end users
rm -f %{buildroot}/%{_sysconfdir}/xen/README*

# standard gnu info files
rm -rf %{buildroot}/usr/info

# adhere to Static Library Packaging Guidelines
rm -rf %{buildroot}/%{_libdir}/*.a

%if %build_efi
# clean up extra efi files
rm -rf %{buildroot}/%{_libdir}/efi
%endif

############ fixup files in /etc ############

# udev
#rm -rf %{buildroot}/etc/udev/rules.d/xen*.rules
#mv %{buildroot}/etc/udev/xen*.rules %{buildroot}/etc/udev/rules.d

# modules
%if %with_sysv
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig/modules
install -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/sysconfig/modules/%{name}.modules
%endif

# logrotate
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d/
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

# init scripts
#mkdir -p %{buildroot}%{_sysconfdir}/rc.d/init.d
#mv %{buildroot}%{_sysconfdir}/init.d/* %{buildroot}%{_sysconfdir}/rc.d/init.d
#rmdir %{buildroot}%{_sysconfdir}/init.d
%if %with_sysv
install -m 755 %{SOURCE20} %{buildroot}%{_sysconfdir}/rc.d/init.d/xenstored
install -m 755 %{SOURCE21} %{buildroot}%{_sysconfdir}/rc.d/init.d/xenconsoled
%else
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xen-watchdog
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xencommons
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xendomains
%endif

# sysconfig
%if %with_sysv
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
install -m 644 %{SOURCE30} %{buildroot}%{_sysconfdir}/sysconfig/xenstored
install -m 644 %{SOURCE31} %{buildroot}%{_sysconfdir}/sysconfig/xenconsoled
%endif

mkdir -p %{buildroot}%{_localstatedir}/run/xenstored

############ create dirs in /var ############

mkdir -p %{buildroot}%{_localstatedir}/lib/xen/images
mkdir -p %{buildroot}%{_localstatedir}/log/xen/console

############ debug packaging: list files ############

find %{buildroot} -print | xargs ls -ld | sed -e 's|.*%{buildroot}||' > f2.list
diff -u f1.list f2.list || true

############ assemble license files ############

mkdir licensedir
# avoid licensedir to avoid recursion, also stubdom/ioemu and dist
# which are copies of files elsewhere
find . -path licensedir -prune -o -path stubdom/ioemu -prune -o \
  -path dist -prune -o -name COPYING -o -name LICENSE | while read file; do
  mkdir -p licensedir/`dirname $file`
  install -m 644 $file licensedir/$file
done

############ all done now ############

%post
%if %with_sysv
/sbin/chkconfig --add xendomains
%endif
%if %with_systemd
%if %with_systemd_presets
%systemd_post xendomains.service
%else
if [ $1 == 1 ]; then
  /bin/systemctl enable xendomains.service
fi
%endif
%endif

%preun
%if %with_systemd_presets
%systemd_preun xendomains.service
%else
if [ $1 == 0 ]; then
%if %with_sysv
  /sbin/chkconfig --del xendomains
%endif
%if %with_systemd
/bin/systemctl disable xendomains.service
%endif
fi
%endif

%if %with_systemd_presets
%postun
%systemd_postun
%endif

%post runtime
%if %with_sysv
/sbin/chkconfig --add xenconsoled
/sbin/chkconfig --add xenstored
%endif
%if %with_systemd
%if %with_systemd_presets
%systemd_post xenstored.service xenconsoled.service
%else
if [ $1 == 1 ]; then
  /bin/systemctl enable xenstored.service
  /bin/systemctl enable xenconsoled.service
fi
%endif
%endif

%if %with_sysv
if [ $1 != 0 ]; then
  service xenconsoled condrestart
fi
%endif

%preun runtime
%if %with_systemd_presets
%systemd_preun xenstored.service xenconsoled.service
%else
if [ $1 == 0 ]; then
%if %with_sysv
  /sbin/chkconfig --del xenconsoled
  /sbin/chkconfig --del xenstored
%endif
%if %with_systemd
  /bin/systemctl disable xenstored.service
  /bin/systemctl disable xenconsoled.service
%endif
fi
%endif

%if %with_systemd_presets
%postun runtime
%systemd_postun
%endif

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%if %build_hyp
%post hypervisor
if [ $1 == 1 -a -f /sbin/grub2-mkconfig -a -f /boot/grub2/grub.cfg ]; then
  /sbin/grub2-mkconfig -o /boot/grub2/grub.cfg
fi

%postun hypervisor
if [ -f /sbin/grub2-mkconfig -a -f /boot/grub2/grub.cfg ]; then
  /sbin/grub2-mkconfig -o /boot/grub2/grub.cfg
fi
%endif

%if %build_ocaml
%post ocaml
%if %with_systemd
%if %with_systemd_presets
%systemd_post oxenstored.service
%else
if [ $1 == 1 ]; then
  /bin/systemctl enable oxenstored.service
fi
%endif
%endif

%preun ocaml
%if %with_systemd
%if %with_systemd_presets
%systemd_preun oxenstored.service
%else
if [ $1 == 0 ]; then
  /bin/systemctl disable oxenstored.service
fi
%endif
%endif

%if %with_systemd_presets
%postun ocaml
%systemd_postun
%endif
%endif

%clean
rm -rf %{buildroot}

# Base package only contains XenD/xm python stuff
#files -f xen-xm.lang
%files
%defattr(-,root,root)
%doc COPYING README
%{_bindir}/xencons
%{python_sitearch}/%{name}
%{python_sitearch}/xen-*.egg-info

# Startup script
%if %with_sysv
%{_sysconfdir}/rc.d/init.d/xendomains
%endif
# Guest autostart links
%dir %attr(0700,root,root) %{_sysconfdir}/%{name}/auto
# Autostart of guests
%config(noreplace) %{_sysconfdir}/sysconfig/xendomains

%if %with_systemd
%{_unitdir}/xendomains.service
%endif

%files libs
%defattr(-,root,root)
%{_libdir}/*.so.*
%{_libdir}/fs

# All runtime stuff except for XenD/xm python stuff
%files runtime
%defattr(-,root,root)
# Hotplug rules
%config(noreplace) %{_sysconfdir}/udev/rules.d/*

%dir %attr(0700,root,root) %{_sysconfdir}/%{name}
%dir %attr(0700,root,root) %{_sysconfdir}/%{name}/scripts/
%config %attr(0700,root,root) %{_sysconfdir}/%{name}/scripts/*

%if %with_sysv
%{_sysconfdir}/rc.d/init.d/xenstored
%{_sysconfdir}/rc.d/init.d/xenconsoled
%{_sysconfdir}/rc.d/init.d/xen-watchdog
%{_sysconfdir}/rc.d/init.d/xencommons
%endif
%{_sysconfdir}/bash_completion.d/xl.sh

%if %with_systemd
%{_unitdir}/proc-xen.mount
%{_unitdir}/var-lib-xenstored.mount
%{_unitdir}/xenstored.service
%{_unitdir}/xenconsoled.service
%{_unitdir}/xen-watchdog.service
%{_unitdir}/xen-qemu-dom0-disk-backend.service
%{_unitdir}/xenstored.socket
%{_unitdir}/xenstored_ro.socket
/usr/lib/modules-load.d/xen.conf
%endif

%if %with_sysv
%config(noreplace) %{_sysconfdir}/sysconfig/xenstored
%config(noreplace) %{_sysconfdir}/sysconfig/xenconsoled
%endif
%config(noreplace) %{_sysconfdir}/sysconfig/xencommons
%config(noreplace) %{_sysconfdir}/xen/xl.conf
%config(noreplace) %{_sysconfdir}/xen/cpupool
%config(noreplace) %{_sysconfdir}/xen/xlexample*

# Auto-load xen backend drivers
%if %with_sysv
%attr(0755,root,root) %{_sysconfdir}/sysconfig/modules/%{name}.modules
%endif

# Rotate console log files
%config(noreplace) %{_sysconfdir}/logrotate.d/xen

# Programs run by other programs
%dir /usr/lib/%{name}
%dir /usr/lib/%{name}/bin
%attr(0700,root,root) /usr/lib/%{name}/bin/*
# QEMU runtime files
%dir %{_datadir}/%{name}/qemu
%dir %{_datadir}/%{name}/qemu/keymaps
%{_datadir}/%{name}/qemu/keymaps/*

# man pages
%{_mandir}/man1/xentop.1*
%{_mandir}/man1/xentrace_format.1*
%{_mandir}/man8/xentrace.8*
%{_mandir}/man1/xl.1*
%{_mandir}/man5/xl.cfg.5*
%{_mandir}/man5/xl.conf.5*
%{_mandir}/man5/xlcpupool.cfg.5*
%{_mandir}/man1/xenstore*

%{python_sitearch}/fsimage.so
%{python_sitearch}/grub
%{python_sitearch}/pygrub-*.egg-info

# The firmware
%ifarch %{ix86} x86_64
%dir /usr/lib/%{name}/boot
/usr/lib/xen/boot/hvmloader
/usr/lib/xen/boot/ioemu-stubdom.gz
/usr/lib/xen/boot/xenstore-stubdom.gz
/usr/lib/xen/boot/pv-grub*.gz
/usr/lib/xen/boot/vtpm-stubdom.gz
/usr/lib/xen/boot/vtpmmgr-stubdom.gz
%endif
# General Xen state
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/lib/%{name}/dump
%dir %{_localstatedir}/lib/%{name}/images
# Xenstore persistent state
%dir %{_localstatedir}/lib/xenstored
# Xenstore runtime state
%ghost %{_localstatedir}/run/xenstored

# All xenstore CLI tools
%{_bindir}/qemu-*-xen
%{_bindir}/xenstore
%{_bindir}/xenstore-*
%{_bindir}/pygrub
%{_bindir}/xentrace*
#%{_bindir}/remus
# blktap daemon
%{_sbindir}/tapdisk*
# XSM
%if %build_xsm
%{_sbindir}/flask-*
%endif
# Disk utils
%{_sbindir}/qcow-create
%{_sbindir}/qcow2raw
%{_sbindir}/img2qcow
# Misc stuff
%{_bindir}/xen-detect
%{_bindir}/xencov_split
%{_sbindir}/gdbsx
%{_sbindir}/gtrace*
%{_sbindir}/kdd
%{_sbindir}/lock-util
%{_sbindir}/tap-ctl
%{_sbindir}/td-util
%{_sbindir}/vhd-*
%{_sbindir}/xen-bugtool
%{_sbindir}/xen-hptool
%{_sbindir}/xen-hvmcrash
%{_sbindir}/xen-hvmctx
%{_sbindir}/xen-tmem-list-parse
%{_sbindir}/xenconsoled
%{_sbindir}/xenlockprof
%{_sbindir}/xenmon.py*
%{_sbindir}/xentop
%{_sbindir}/xentrace_setmask
%{_sbindir}/xenbaked
%{_sbindir}/xenstored
%{_sbindir}/xenpm
%{_sbindir}/xenpmd
%{_sbindir}/xenperf
%{_sbindir}/xenwatchdogd
%{_sbindir}/xl
%{_sbindir}/xen-lowmemd
%{_sbindir}/xen-ringwatch
%{_sbindir}/xencov
%{_sbindir}/xen-mfndump

# Xen logfiles
%dir %attr(0700,root,root) %{_localstatedir}/log/xen
# Guest/HV console logs
%dir %attr(0700,root,root) %{_localstatedir}/log/xen/console

%files hypervisor
%if %build_hyp
%defattr(-,root,root)
/boot/xen-syms-*
/boot/xen-*.gz
/boot/xen.gz
%if %build_xsm
%dir %attr(0755,root,root) /boot/flask
/boot/flask/xenpolicy*
%endif
%if %build_efi
/boot/efi/EFI/fedora/*.efi
%endif
%endif

%files doc
%defattr(-,root,root)
%doc docs/misc/
%doc dist/install/usr/share/doc/xen/html

%files devel
%defattr(-,root,root)
%{_includedir}/*.h
%dir %{_includedir}/xen
%{_includedir}/xen/*
%dir %{_includedir}/xenstore-compat
%{_includedir}/xenstore-compat/*
%{_libdir}/*.so

%files licenses
%defattr(-,root,root)
%doc licensedir/*

%if %build_ocaml
%files ocaml
%defattr(-,root,root)
%{_libdir}/ocaml/xen*
%exclude %{_libdir}/ocaml/xen*/*.a
%exclude %{_libdir}/ocaml/xen*/*.cmxa
%exclude %{_libdir}/ocaml/xen*/*.cmx
%{_libdir}/ocaml/stublibs/*.so
%{_libdir}/ocaml/stublibs/*.so.owner
%{_sbindir}/oxenstored
%config(noreplace) %{_sysconfdir}/xen/oxenstored.conf
%{_unitdir}/oxenstored.service

%files ocaml-devel
%defattr(-,root,root)
%{_libdir}/ocaml/xen*/*.a
%{_libdir}/ocaml/xen*/*.cmxa
%{_libdir}/ocaml/xen*/*.cmx
%endif

%changelog
* Fri Feb 06 2015 Yohsuke Ooi <meke@momonga-linux.org>
- (4.5-1m)
- update 4.5

* Sat Jan 31 2015 Yohsuke Ooi <meke@momonga-linux.org>
- (4.4.1-2m)
- no build cross hypervisor(i686)

* Fri Jan 30 2015 Yohsuke Ooi <meke@momonga-linux.org>
- (4.4.1-1m)
- update 4.4.1

* Fri Apr 11 2014 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (4.1.5-6m)
- rebuild against graphviz-2.36.0-1m

* Sat Mar 22 2014 NARITA Koichi <pulsar@momonga-linux.org>
- (4.1.5-5m)
- rebuild against brltty-5.0

* Fri Nov 22 2013 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.5-4m)
- update service files

* Tue Oct 15 2013 NARITA Koichi <pulsar@momonga-linux.org>
- (4.1.5-3m)
- [SECURITY] CVE-2013-2072 CVE-2013-2076 CVE-2013-2077 CVE-2013-2078
- [SECURITY] CVE-2013-2194 CVE-2013-2195 CVE-2013-2196 CVE-2013-2211
- [SECURITY] CVE-2013-2212 CVE-2013-3495 CVE-2013-4329

* Tue Sep 24 2013 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (4.1.5-2m)
- add build fix Patch6: xen-4.1.5-glibc217.patch

* Sun Jun  2 2013 NARITA Koichi <pulsar@momonga-linux.org>
- (4.1.5-1m)
- [SECURITY] CVE-2012-3494 CVE-2012-3495 CVE-2012-3496 CVE-2012-3498
- [SECURITY] CVE-2012-3515 CVE-2012-4411 CVE-2012-5634 CVE-2012-6075
- [SECURITY] CVE-2013-1917 CVE-2013-1918 CVE-2013-1919 CVE-2013-1920
- [SECURITY] CVE-2013-1952 CVE-2013-1964
- update to 4.1.5

* Sat Jun  1 2013 NARITA Koichi <pulsar@momonga-linux.org>
- (4.1.3-4m)
- rebuild against gnutls-3.2.0

* Thu Feb  7 2013 NARITA Koichi <pulsar@momonga-linux.org>
- (4.1.3-3m)
- [SECURITY] CVE-2012-5510 CVE-2012-5511 CVE-2012-5512 CVE-2012-5513
- [SECURITY] CVE-2012-5514 CVE-2012-5515 CVE-2012-5634 CVE-2013-0153
- [SECURITY] CVE-2013-0154 CVE-2013-0215

* Tue Nov 27 2012 NARITA Koichi <pulsar@momonga-linux.org>
- (4.1.3-2m)
- [SECURITY] CVE-2012-4535 CVE-2012-4536 CVE-2012-4537 CVE-2012-4538
- [SECURITY] CVE-2012-4539 CVE-2012-4544 CVE-2012-2625

* Mon Aug 20 2012 NARITA Koichi <pulsar@momonga-linux.org>
- (4.1.3-1m)
- [SECURITY] CVE-2012-3432 CVE-2012-3433
- update to 4.1.3

* Sat Jun 16 2012 NARITA Koichi <pulsar@momonga-linux.org>
- (4.1.2-3m)
- [SECURITY] CVE-2012-0217

* Mon Feb 20 2012 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.1.2-2m)
- add systemd service file
- [SECURITY] CVE-2012-0029

* Sat Oct 29 2011 Masahiro Takahata <takahata@momonga-linux.org>
- (4.1.2-1m)
- version up 4.1.2

* Mon Jul  4 2011 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.1.0-3m)
- Obsoletes: xenner

* Tue Jun 14 2011 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.1.0-2m)
- set OCAML_TOOLS ?= n to enable build
- release %%{_includedir}/xen, it's provided by kernel-headers

* Sun Jun 12 2011 Masahiro Takahata <takahata@momonga-linux.org>
- (4.1.0-1m)
- sync Fedora 15

* Tue May  3 2011 Yohsuke Ooi <meke@momonga-linux.org> 
- (3.4.3-10m)
- rebuild against python-2.7

* Tue Apr 26 2011 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.3-9m)
- fix build by gcc46
- [CAUTION] touch .config to enable build only, fix me

* Mon Apr 11 2011 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (3.4.3-8m)
- rebuild for new GCC 4.6

* Thu Dec  2 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (3.4.3-7m)
- [SECURITY] http://lists.xensource.com/archives/html/xen-devel/2010-11/msg01650.html
- fix build (import gcc45 patch from Fedora devel)

* Sun Nov 28 2010 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (3.4.3-6m)
- rebuild for new GCC 4.5

* Tue Oct 26 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (3.4.3-5m)
- rebuild against xz-5.0.0

* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (3.4.3-4m)
- full rebuild for mo7 release

* Sun Aug 29 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.3-3m)
- fix up

* Sun Aug 29 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (3.4.3-2m)
- do not start all daemons at start up time

* Thu Jul 22 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.4.3-1m)
- sync with Fedora 13 (3.4.3-2)

* Mon May  3 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (3.4.1-7m)
- fix build with gcc-4.4.4

* Sun Apr 25 2010 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.4.1-6m)
- use Requires

* Sat Feb 20 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.4.1-5m)
- apply glibc212 patch

* Sat Jan  2 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.1-4m)
- release %%{_includedir}/xen, it's provided by kernel-headers

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.4.1-3m)
- rebuild against gcc-4.4 and glibc-2.11

* Sun Sep 20 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.4.1-2m)
- BuildRequires: graphviz

* Sun Sep 20 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.4.1-1m)
- sync with Rawhide (3.4.1-4)

* Sun Jul 19 2009 Ryu SASAOKA <ryu@momonga-linux.org>
- (3.3.1-3m)
- stop daemon. modify Patch1

* Wed May 13 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.3.1-2m)
- modify Requires of xen-runtime
- move startup scripts from %%{_initrddir} to %%{_initscriptdir}

* Tue May 12 2009 Masahiro Takahata <takahata@momonga-linux.org>
- (3.3.1-1m)
- [SECURITY] CVE-2008-4405 CVE-2008-5716
- sync Fedora

* Tue Apr 07 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.2.0-16m)
- rebuild against openssl-0.9.8k

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.2.0-15m)
- rebuild against rpm-4.6

* Sun Jan 18 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.2.0-14m)
- [SECURITY] CVE-2008-0928
- import a security patch (Patch16) from Fedora 9 (3.2.0-15.fc9)

* Sat Jan 17 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.2.0-13m)
- [SECURITY] CVE-2008-1943 CVE-2008-1952 CVE-2008-1945 CVE-2008-2004
- import security patches from Fedora 9 (3.2.0-15.fc9)
-- Patch37 (CVE-2008-{1943,1952})
-- Patch38 (CVE-2008-{1945,2004})
- update Patch8 from Fedora 9 (3.2.0-15.fc9)
- update Patch3,13,102 for fuzz=0
- License: GPLv2+ and LGPLv2+ and Modified BSD

* Wed Dec 31 2008 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (3.2.0-12m)
- rebuild agaisst python-2.6.1-1m

* Tue Jul 15 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (3.2.0-11m)
- rebuild against gnutls-2.4.1

* Thu Jun  5 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (3.2.0-10m)
- rebuild against openssl-0.9.8h-1m

* Wed Apr 30 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.0-9m)
- restrict python ver-rel for egginfo

* Tue Apr 29 2008 Masahiro Takahata <takahata@momonga-linux.org>
- (3.2.0-8m)
- enable egg-info

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.0-7m)
- rebuild against gcc43

* Fri Feb 15 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.2.0-6m)
- adjust %%files for the newest python
- BR: python-devel >= 2.5.1-7m

* Mon Feb 11 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.2.0-5m)
- adjust %%files again for x86_64

* Fri Feb  8 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.2.0-4m)
- adjust %%files for new python
- BR: python-devel >= 2.5.1-5m

* Thu Feb  7 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.0-3m)
- fix files conflicts

* Sat Feb  2 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (3.2.0-2m)
- split xen-runtime

* Thu Jan 31 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (3.2.0-1m)
- [SECURITY] CVE-2007-5906 CVE-2007-5907
- update 3.2.0

* Mon Dec  3 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (3.1.2-1m)
- update 3.1.2

* Tue Oct 30 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (3.1.0-3m)
- cleanup spec
- fix CVE-2007-1321, CVE-2007-3919, CVE-2007-4993
-- import Fedora Patches(3.1.0-13)
 
* Mon Jul 23 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (3.1.0-2m)
- add Requires: initscripts
- fix %%post PATH to service
 
* Tue Jun 19 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (3.1.0-1m)
- up to 3.1.0
- be synchronized with fedora
- modify initscripts

* Fri Jun  8 2007 Masahiro Takahata <takahata@momonga-linux.org>
- (3.1.0-0.rc7.1m)
- sync Fedora

* Wed Mar 14 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (3.0.3-4m)
- makimodosi 3.0.3-2

* Wed Mar 14 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (3.0.3-3m)
- add export LDFLAGS="-L/%{_lib} $LDFLAGS"
-- Because /lib/libncurses.so cannot be linked

* Sat Dec 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (3.0.3-2m)
- rebuild against python-2.5

* Mon Oct 06 2006 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.0.3-1m)
- merge FC 3.0.3-1

* Fri Jul  7 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0.2-1m)
- import from fc-devel

* Sun Jan  8 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0-0.20051206.1m)
- sync with fc-devel

* Sat Oct 30 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (2-20051030m)
- rebuild against python-2.4.2

* Wed Mar 23 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (2-20050308m)
- import from FC

* Wed Mar  9 2005 Rik van Riel <riel@redhat.com> 2-20050308
- upgrade to last night's snapshot
- new compile fix patch

* Sun Mar  6 2005 Rik van Riel <riel@redhat.com> 2-20050305
- the gcc4 compile patches are now upstream
- upgrade to last night's snapshot, drop patches locally

* Fri Mar  4 2005 Rik van Riel <riel@redhat.com> 2-20050303
- finally got everything to compile with gcc4 -Wall -Werror

* Thu Mar  3 2005 Rik van Riel <riel@redhat.com> 2-20050303
- upgrade to last night's Xen-unstable snapshot
- drop printf warnings patch, which is upstream now

* Wed Feb 23 2005 Rik van Riel <riel@redhat.com> 2-20050222
- upgraded to last night's Xen snapshot
- compile warning fixes are now upstream, drop patch

* Sat Feb 19 2005 Rik van Riel <riel@redhat.com> 2-20050219
- fix more compile warnings
- fix the fwrite return check

* Fri Feb 18 2005 Rik van Riel <riel@redhat.com> 2-20050218
- upgrade to last night's Xen snapshot
- a kernel upgrade is needed to run this Xen, the hypervisor
  interface changed slightly
- comment out unused debugging function in plan9 domain builder
  that was giving compile errors with -Werror

* Tue Feb  8 2005 Rik van Riel <riel@redhat.com> 2-20050207
- upgrade to last night's Xen snapshot

* Tue Feb  1 2005 Rik van Riel <riel@redhat.com> 2-20050201.1
- move everything to /var/lib/xen

* Tue Feb  1 2005 Rik van Riel <riel@redhat.com> 2-20050201
- upgrade to new upstream Xen snapshot

* Tue Jan 25 2005 Jeremy Katz <katzj@redhat.com>
- add buildreqs on python-devel and xorg-x11-devel (strange AT nsk.no-ip.org)

* Mon Jan 24 2005 Rik van Riel <riel@redhat.com> - 2-20050124
- fix /etc/xen/scripts/network to not break with ipv6 (also sent upstream)

* Fri Jan 14 2005 Jeremy Katz <katzj@redhat.com> - 2-20050114
- update to new snap
- python-twisted is its own package now
- files are in /usr/lib/python now as well, ugh.

* Tue Jan 11 2005 Rik van Riel <riel@redhat.com>
- add segment fixup patch from xen tree
- fix %files list for python-twisted

* Mon Jan 10 2005 Rik van Riel <riel@redhat.com>
- grab newer snapshot, that does start up
- add /var/xen/xend-db/{domain,vnet} to %files section

* Thu Jan  6 2005 Rik van Riel <riel@redhat.com>
- upgrade to new snapshot of xen-unstable

* Mon Dec 13 2004 Rik van Riel <riel@redhat.com>
- build python-twisted as a subpackage
- update to latest upstream Xen snapshot

* Sun Dec  5 2004 Rik van Riel <riel@redhat.com>
- grab new Xen tarball (with wednesday's patch already included)
- transfig is a buildrequire, add it to the spec file

* Wed Dec  1 2004 Rik van Riel <riel@redhat.com>
- fix up Che's spec file a little bit
- create patch to build just Xen, not the kernels

* Wed Dec 01 2004 Che
- initial rpm release
